﻿using System;
using System.ComponentModel;

namespace WpfApplication5
{
    public class NotifyPropertyChanged : INotifyPropertyChanged
    {
        #region INotifyPropertyChanged Members
        public event PropertyChangedEventHandler PropertyChanged;

        public void OnPropertyChanged(string propertyName)
        {
            PropertyChangedEventHandler handler = this.PropertyChanged;

            if (handler != null)
            {
                handler(this, new PropertyChangedEventArgs(propertyName));
            }
        }

        public void ClearAllPropertyChangedHandlers()
        {
            if (this.PropertyChanged == null)
            {
                return;
            }

            foreach (PropertyChangedEventHandler handler in this.PropertyChanged.GetInvocationList())
            {
                this.PropertyChanged -= handler;
            }
        }
        #endregion
    }
}
