﻿using System;
using System.Windows;
using System.Windows.Input;

namespace WpfApplication5
{
    public class Window1ViewModel : BaseViewModel
    {
        private string _txt;
        public string Txt
        {
            get
            {
                return _txt;
            }
            set
            {
                _txt = value;
                this.OnPropertyChanged("Txt");
            }
        }

        private DelegateCommand<object> _testSendMailCommand;
        public ICommand TestSendMailCommand
        {
            get
            {
                return _testSendMailCommand ??
                    (_testSendMailCommand = new DelegateCommand<object>(
                        param => this.ExecuteTestSendMailCommand(),
                        param => this.CanExecuteTestSendMailCommand()));
            }
        }

        private DelegateCommand<System.ComponentModel.CancelEventArgs> _windowClosingCommand;
        public ICommand WindowClosingCommand
        {
            get
            {
                return _windowClosingCommand ??
                    (_windowClosingCommand = new DelegateCommand<System.ComponentModel.CancelEventArgs>(
                        param => this.ExecuteWindowClosingCommand(param), null));
            }
        }

        private void ExecuteTestSendMailCommand()
        {
            MessageBox.Show("asdasdasd");
        }

        private bool CanExecuteTestSendMailCommand()
        {
            return (string.IsNullOrWhiteSpace(Txt) == false);
        }

        private void ExecuteWindowClosingCommand(System.ComponentModel.CancelEventArgs param)
        {
            _testSendMailCommand = null;
            this.Dispose();
        }
    }
}
